Add tests for LVs parser
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 storagedir = $(pkgpythondir)/storage
46 httpdir = $(pkgpythondir)/http
47 masterddir = $(pkgpythondir)/masterd
48 confddir = $(pkgpythondir)/confd
49 rapidir = $(pkgpythondir)/rapi
50 serverdir = $(pkgpythondir)/server
51 watcherdir = $(pkgpythondir)/watcher
52 impexpddir = $(pkgpythondir)/impexpd
53 utilsdir = $(pkgpythondir)/utils
54 toolsdir = $(pkglibdir)/tools
55 iallocatorsdir = $(pkglibdir)/iallocators
56 pytoolsdir = $(pkgpythondir)/tools
57 docdir = $(datadir)/doc/$(PACKAGE)
58 myexeclibdir = $(pkglibdir)
59
60 # Delete output file if an error occurred while building it
61 .DELETE_ON_ERROR:
62
63 HS_DIRS = \
64         src \
65         src/Ganeti \
66         src/Ganeti/Confd \
67         src/Ganeti/Curl \
68         src/Ganeti/DataCollectors \
69         src/Ganeti/HTools \
70         src/Ganeti/HTools/Backend \
71         src/Ganeti/HTools/Program \
72         src/Ganeti/Hypervisor \
73         src/Ganeti/Hypervisor/Xen \
74         src/Ganeti/Monitoring \
75         src/Ganeti/Query \
76         src/Ganeti/Storage \
77         src/Ganeti/Storage/Diskstats \
78         src/Ganeti/Storage/Drbd \
79         src/Ganeti/Storage/Lvm \
80         test/hs \
81         test/hs/Test \
82         test/hs/Test/Ganeti \
83         test/hs/Test/Ganeti/Storage \
84         test/hs/Test/Ganeti/Storage/Diskstats \
85         test/hs/Test/Ganeti/Storage/Drbd \
86         test/hs/Test/Ganeti/Storage/Lvm \
87         test/hs/Test/Ganeti/Confd \
88         test/hs/Test/Ganeti/HTools \
89         test/hs/Test/Ganeti/HTools/Backend \
90         test/hs/Test/Ganeti/Hypervisor \
91         test/hs/Test/Ganeti/Hypervisor/Xen \
92         test/hs/Test/Ganeti/Query
93
94 # Haskell directories without the roots (src, test/hs)
95 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
96
97 DIRS = \
98         $(HS_DIRS) \
99         autotools \
100         daemons \
101         devel \
102         devel/data \
103         doc \
104         doc/css \
105         doc/examples \
106         doc/examples/gnt-debug \
107         doc/examples/hooks \
108         test/data/htools \
109         test/data/htools/rapi \
110         test/hs/shelltests \
111         test/autotools \
112         lib \
113         lib/build \
114         lib/client \
115         lib/cmdlib \
116         lib/confd \
117         lib/http \
118         lib/hypervisor \
119         lib/impexpd \
120         lib/masterd \
121         lib/rapi \
122         lib/server \
123         lib/storage \
124         lib/tools \
125         lib/utils \
126         lib/watcher \
127         man \
128         qa \
129         test \
130         test/data \
131         test/data/bdev-rbd \
132         test/data/ovfdata \
133         test/data/ovfdata/other \
134         test/py \
135         tools
136
137 ALL_APIDOC_HS_DIRS = \
138         $(APIDOC_HS_DIR) \
139         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
140
141 BUILDTIME_DIR_AUTOCREATE = \
142         scripts \
143         $(APIDOC_DIR) \
144         $(ALL_APIDOC_HS_DIRS) \
145         $(APIDOC_PY_DIR) \
146         $(COVERAGE_DIR) \
147         $(COVERAGE_HS_DIR) \
148         $(COVERAGE_PY_DIR) \
149         .hpc
150
151 BUILDTIME_DIRS = \
152         $(BUILDTIME_DIR_AUTOCREATE) \
153         doc/html \
154         doc/man-html
155
156 DIRCHECK_EXCLUDE = \
157         $(BUILDTIME_DIRS) \
158         ganeti-[0-9]*.[0-9]*.[0-9]* \
159         doc/html/_* \
160         doc/man-html/_* \
161         autom4te.cache
162
163 # some helper vars
164 COVERAGE_DIR = doc/coverage
165 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
166 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
167 APIDOC_DIR = doc/api
168 APIDOC_PY_DIR = $(APIDOC_DIR)/py
169 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
170
171 MAINTAINERCLEANFILES = \
172         $(maninput) \
173         doc/install-quick.rst \
174         doc/news.rst \
175         doc/upgrade.rst \
176         vcs-version
177
178 maintainer-clean-local:
179         rm -rf $(BUILDTIME_DIRS)
180
181 CLEANFILES = \
182         $(addsuffix /*.py[co],$(DIRS)) \
183         $(addsuffix /*.hi,$(HS_DIRS)) \
184         $(addsuffix /*.o,$(HS_DIRS)) \
185         $(PYTHON_BOOTSTRAP) \
186         epydoc.conf \
187         $(REPLACE_VARS_SED) \
188         $(SHELL_ENV_INIT) \
189         daemons/daemon-util \
190         daemons/ganeti-cleaner \
191         devel/squeeze-amd64.tar.gz \
192         devel/squeeze-amd64.conf \
193         $(mandocrst) \
194         doc/manpages-enabled.rst \
195         $(BUILT_EXAMPLES) \
196         doc/examples/bash_completion \
197         doc/examples/bash_completion-debug \
198         lib/_generated_rpc.py \
199         $(man_MANS) \
200         $(manhtml) \
201         tools/kvm-ifup \
202         tools/vif-ganeti \
203         tools/net-common \
204         tools/users-setup \
205         tools/vcluster-setup \
206         stamp-directories \
207         stamp-srclinks \
208         $(nodist_pkgpython_PYTHON) \
209         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
210         $(HS_BUILT_TEST_HELPERS) \
211         src/ganeti-confd \
212         src/ganeti-mond \
213         .hpc/*.mix src/*.tix test/hs/*.tix \
214         doc/hs-lint.html
215
216 GENERATED_FILES = \
217         $(built_base_sources) \
218         $(BUILT_PYTHON_SOURCES) \
219         $(PYTHON_BOOTSTRAP)
220
221 HS_GENERATED_FILES =
222 if WANT_HTOOLS
223 HS_GENERATED_FILES += $(HS_PROGS)
224 if ENABLE_CONFD
225 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
226 endif
227
228 if ENABLE_MOND
229 HS_GENERATED_FILES += src/ganeti-mond
230 endif
231 endif
232
233 built_base_sources = \
234         stamp-directories \
235         stamp-srclinks
236
237 built_python_base_sources = \
238         lib/_autoconf.py \
239         lib/_vcsversion.py
240
241 BUILT_PYTHON_SOURCES = \
242         $(built_python_base_sources) \
243         lib/_generated_rpc.py
244
245 # Generating the RPC wrappers depends on many things, so make sure
246 # it's built at the end of the built sources
247 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
248
249 # these are all built from the underlying %.in sources
250 BUILT_EXAMPLES = \
251         doc/examples/ganeti-kvm-poweroff.initd \
252         doc/examples/ganeti.cron \
253         doc/examples/ganeti.initd \
254         doc/examples/ganeti-master-role.ocf \
255         doc/examples/ganeti-node-role.ocf \
256         doc/examples/gnt-config-backup \
257         doc/examples/hooks/ipsec
258
259 nodist_pkgpython_PYTHON = \
260         $(BUILT_PYTHON_SOURCES)
261
262 noinst_PYTHON = \
263         lib/build/__init__.py \
264         lib/build/shell_example_lexer.py \
265         lib/build/sphinx_ext.py
266
267 pkgpython_PYTHON = \
268         lib/__init__.py \
269         lib/asyncnotifier.py \
270         lib/backend.py \
271         lib/bootstrap.py \
272         lib/cli.py \
273         lib/compat.py \
274         lib/config.py \
275         lib/constants.py \
276         lib/daemon.py \
277         lib/errors.py \
278         lib/hooksmaster.py \
279         lib/ht.py \
280         lib/jqueue.py \
281         lib/jstore.py \
282         lib/locking.py \
283         lib/luxi.py \
284         lib/mcpu.py \
285         lib/netutils.py \
286         lib/objects.py \
287         lib/opcodes.py \
288         lib/outils.py \
289         lib/ovf.py \
290         lib/pathutils.py \
291         lib/qlang.py \
292         lib/query.py \
293         lib/rpc.py \
294         lib/rpc_defs.py \
295         lib/runtime.py \
296         lib/serializer.py \
297         lib/ssconf.py \
298         lib/ssh.py \
299         lib/uidpool.py \
300         lib/vcluster.py \
301         lib/network.py \
302         lib/workerpool.py
303
304 client_PYTHON = \
305         lib/client/__init__.py \
306         lib/client/gnt_backup.py \
307         lib/client/gnt_cluster.py \
308         lib/client/gnt_debug.py \
309         lib/client/gnt_group.py \
310         lib/client/gnt_instance.py \
311         lib/client/gnt_job.py \
312         lib/client/gnt_node.py \
313         lib/client/gnt_network.py \
314         lib/client/gnt_os.py \
315         lib/client/gnt_storage.py
316
317 cmdlib_PYTHON = \
318         lib/cmdlib/__init__.py \
319         lib/cmdlib/backup.py \
320         lib/cmdlib/base.py \
321         lib/cmdlib/cluster.py \
322         lib/cmdlib/common.py \
323         lib/cmdlib/group.py \
324         lib/cmdlib/instance.py \
325         lib/cmdlib/instance_migration.py \
326         lib/cmdlib/instance_operation.py \
327         lib/cmdlib/instance_query.py \
328         lib/cmdlib/instance_storage.py \
329         lib/cmdlib/instance_utils.py \
330         lib/cmdlib/misc.py \
331         lib/cmdlib/network.py \
332         lib/cmdlib/node.py \
333         lib/cmdlib/operating_system.py \
334         lib/cmdlib/query.py \
335         lib/cmdlib/tags.py \
336         lib/cmdlib/test.py
337
338 hypervisor_PYTHON = \
339         lib/hypervisor/__init__.py \
340         lib/hypervisor/hv_base.py \
341         lib/hypervisor/hv_chroot.py \
342         lib/hypervisor/hv_fake.py \
343         lib/hypervisor/hv_kvm.py \
344         lib/hypervisor/hv_lxc.py \
345         lib/hypervisor/hv_xen.py
346
347 storage_PYTHON = \
348         lib/storage/__init__.py \
349         lib/storage/bdev.py \
350         lib/storage/base.py \
351         lib/storage/container.py \
352         lib/storage/drbd.py \
353         lib/storage/drbd_info.py \
354         lib/storage/drbd_cmdgen.py \
355         lib/storage/filestorage.py
356
357 rapi_PYTHON = \
358         lib/rapi/__init__.py \
359         lib/rapi/baserlib.py \
360         lib/rapi/client.py \
361         lib/rapi/client_utils.py \
362         lib/rapi/connector.py \
363         lib/rapi/rlib2.py \
364         lib/rapi/testutils.py
365
366 http_PYTHON = \
367         lib/http/__init__.py \
368         lib/http/auth.py \
369         lib/http/client.py \
370         lib/http/server.py
371
372 confd_PYTHON = \
373         lib/confd/__init__.py \
374         lib/confd/client.py
375
376 masterd_PYTHON = \
377         lib/masterd/__init__.py \
378         lib/masterd/iallocator.py \
379         lib/masterd/instance.py
380
381 impexpd_PYTHON = \
382         lib/impexpd/__init__.py
383
384 watcher_PYTHON = \
385         lib/watcher/__init__.py \
386         lib/watcher/nodemaint.py \
387         lib/watcher/state.py
388
389 server_PYTHON = \
390         lib/server/__init__.py \
391         lib/server/masterd.py \
392         lib/server/noded.py \
393         lib/server/rapi.py
394
395 pytools_PYTHON = \
396         lib/tools/__init__.py \
397         lib/tools/burnin.py \
398         lib/tools/ensure_dirs.py \
399         lib/tools/node_cleanup.py \
400         lib/tools/node_daemon_setup.py \
401         lib/tools/prepare_node_join.py
402
403 utils_PYTHON = \
404         lib/utils/__init__.py \
405         lib/utils/algo.py \
406         lib/utils/filelock.py \
407         lib/utils/hash.py \
408         lib/utils/io.py \
409         lib/utils/log.py \
410         lib/utils/lvm.py \
411         lib/utils/mlock.py \
412         lib/utils/nodesetup.py \
413         lib/utils/process.py \
414         lib/utils/retry.py \
415         lib/utils/storage.py \
416         lib/utils/text.py \
417         lib/utils/wrapper.py \
418         lib/utils/x509.py
419
420 docinput = \
421         doc/conf.py \
422         doc/css/style.css \
423         doc/admin.rst \
424         doc/cluster-merge.rst \
425         doc/design-2.0.rst \
426         doc/design-2.1.rst \
427         doc/design-2.2.rst \
428         doc/design-2.3.rst \
429         doc/design-2.4.rst \
430         doc/design-2.5.rst \
431         doc/design-2.6.rst \
432         doc/design-2.7.rst \
433         doc/design-2.8.rst \
434         doc/design-autorepair.rst \
435         doc/design-bulk-create.rst \
436         doc/design-chained-jobs.rst \
437         doc/design-cpu-pinning.rst \
438         doc/design-device-uuid-name.rst \
439         doc/design-draft.rst \
440         doc/design-htools-2.3.rst \
441         doc/design-http-server.rst \
442         doc/design-impexp2.rst \
443         doc/design-internal-shutdown.rst \
444         doc/design-lu-generated-jobs.rst \
445         doc/design-linuxha.rst \
446         doc/design-multi-reloc.rst \
447         doc/design-network.rst \
448         doc/design-node-add.rst \
449         doc/design-oob.rst \
450         doc/design-ovf-support.rst \
451         doc/design-opportunistic-locking.rst \
452         doc/design-partitioned.rst \
453         doc/design-query-splitting.rst \
454         doc/design-query2.rst \
455         doc/design-reason-trail.rst \
456         doc/design-resource-model.rst \
457         doc/design-restricted-commands.rst \
458         doc/design-shared-storage.rst \
459         doc/design-monitoring-agent.rst \
460         doc/design-virtual-clusters.rst \
461         doc/design-x509-ca.rst \
462         doc/design-hroller.rst \
463         doc/design-storagetypes.rst \
464         doc/devnotes.rst \
465         doc/glossary.rst \
466         doc/hooks.rst \
467         doc/iallocator.rst \
468         doc/index.rst \
469         doc/install-quick.rst \
470         doc/install.rst \
471         doc/locking.rst \
472         doc/manpages-disabled.rst \
473         doc/move-instance.rst \
474         doc/news.rst \
475         doc/ovfconverter.rst \
476         doc/rapi.rst \
477         doc/security.rst \
478         doc/upgrade.rst \
479         doc/virtual-cluster.rst \
480         doc/walkthrough.rst
481
482 # Generates file names such as "doc/man-gnt-instance.rst"
483 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
484
485 # Haskell programs to be installed in $PREFIX/bin
486 HS_BIN_PROGS=src/htools
487
488 # Haskell programs to be installed in the MYEXECLIB dir
489 if ENABLE_MOND
490 HS_MYEXECLIB_PROGS=src/mon-collector
491 else
492 HS_MYEXECLIB_PROGS=
493 endif
494
495 # Haskell programs to be compiled by "make really-all"
496 HS_COMPILE_PROGS= \
497         src/ganeti-mond \
498         src/hconfd \
499         src/rpc-test
500
501 # All Haskell non-test programs to be compiled but not automatically installed
502 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
503
504 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
505 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
506
507 HS_ALL_PROGS = \
508         $(HS_PROGS) \
509         test/hs/hpc-htools \
510         test/hs/hpc-mon-collector \
511         test/hs/htest \
512         $(HS_COMPILE_PROGS)
513
514 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
515 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
516
517 HFLAGS = \
518         -O -Wall -Werror -isrc \
519         -fwarn-monomorphism-restriction \
520         -fwarn-tabs \
521         $(GHC_BYVERSION_FLAGS)
522
523 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
524 HEXTRA =
525 # internal extra flags (used for test/hs/htest mainly)
526 HEXTRA_INT =
527 # exclude options for coverage reports
528 HPCEXCL = --exclude Main \
529         --exclude Ganeti.Constants \
530         --exclude Ganeti.HTools.QC \
531         --exclude Ganeti.THH \
532         --exclude Ganeti.Version \
533         --exclude Test.Ganeti.Attoparsec \
534         --exclude Test.Ganeti.TestCommon \
535         --exclude Test.Ganeti.TestHTools \
536         --exclude Test.Ganeti.TestHelper \
537         --exclude Test.Ganeti.TestImports \
538         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
539
540 HS_LIB_SRCS = \
541         src/Ganeti/BasicTypes.hs \
542         src/Ganeti/Common.hs \
543         src/Ganeti/Compat.hs \
544         src/Ganeti/Confd/Client.hs \
545         src/Ganeti/Confd/Server.hs \
546         src/Ganeti/Confd/Types.hs \
547         src/Ganeti/Confd/Utils.hs \
548         src/Ganeti/Config.hs \
549         src/Ganeti/Curl/Multi.hs \
550         src/Ganeti/Daemon.hs \
551         src/Ganeti/DataCollectors/CLI.hs \
552         src/Ganeti/DataCollectors/Diskstats.hs \
553         src/Ganeti/DataCollectors/Drbd.hs \
554         src/Ganeti/DataCollectors/InstStatus.hs \
555         src/Ganeti/DataCollectors/InstStatusTypes.hs \
556         src/Ganeti/DataCollectors/Program.hs \
557         src/Ganeti/DataCollectors/Types.hs \
558         src/Ganeti/Errors.hs \
559         src/Ganeti/HTools/Backend/IAlloc.hs \
560         src/Ganeti/HTools/Backend/Luxi.hs \
561         src/Ganeti/HTools/Backend/Rapi.hs \
562         src/Ganeti/HTools/Backend/Simu.hs \
563         src/Ganeti/HTools/Backend/Text.hs \
564         src/Ganeti/HTools/CLI.hs \
565         src/Ganeti/HTools/Cluster.hs \
566         src/Ganeti/HTools/Container.hs \
567         src/Ganeti/HTools/ExtLoader.hs \
568         src/Ganeti/HTools/Graph.hs \
569         src/Ganeti/HTools/Group.hs \
570         src/Ganeti/HTools/Instance.hs \
571         src/Ganeti/HTools/Loader.hs \
572         src/Ganeti/HTools/Nic.hs \
573         src/Ganeti/HTools/Node.hs \
574         src/Ganeti/HTools/PeerMap.hs \
575         src/Ganeti/HTools/Program/Hail.hs \
576         src/Ganeti/HTools/Program/Harep.hs \
577         src/Ganeti/HTools/Program/Hbal.hs \
578         src/Ganeti/HTools/Program/Hcheck.hs \
579         src/Ganeti/HTools/Program/Hinfo.hs \
580         src/Ganeti/HTools/Program/Hscan.hs \
581         src/Ganeti/HTools/Program/Hspace.hs \
582         src/Ganeti/HTools/Program/Hroller.hs \
583         src/Ganeti/HTools/Program/Main.hs \
584         src/Ganeti/HTools/Types.hs \
585         src/Ganeti/Hypervisor/Xen.hs \
586         src/Ganeti/Hypervisor/Xen/XmParser.hs \
587         src/Ganeti/Hypervisor/Xen/Types.hs \
588         src/Ganeti/Hash.hs \
589         src/Ganeti/JQueue.hs \
590         src/Ganeti/JSON.hs \
591         src/Ganeti/Jobs.hs \
592         src/Ganeti/Logging.hs \
593         src/Ganeti/Luxi.hs \
594         src/Ganeti/Monitoring/Server.hs \
595         src/Ganeti/Network.hs \
596         src/Ganeti/Objects.hs \
597         src/Ganeti/OpCodes.hs \
598         src/Ganeti/OpParams.hs \
599         src/Ganeti/Path.hs \
600         src/Ganeti/Query/Cluster.hs \
601         src/Ganeti/Query/Common.hs \
602         src/Ganeti/Query/Export.hs \
603         src/Ganeti/Query/Filter.hs \
604         src/Ganeti/Query/Group.hs \
605         src/Ganeti/Query/Job.hs \
606         src/Ganeti/Query/Language.hs \
607         src/Ganeti/Query/Network.hs \
608         src/Ganeti/Query/Node.hs \
609         src/Ganeti/Query/Query.hs \
610         src/Ganeti/Query/Server.hs \
611         src/Ganeti/Query/Types.hs \
612         src/Ganeti/Rpc.hs \
613         src/Ganeti/Runtime.hs \
614         src/Ganeti/Ssconf.hs \
615         src/Ganeti/Storage/Diskstats/Parser.hs \
616         src/Ganeti/Storage/Diskstats/Types.hs \
617         src/Ganeti/Storage/Drbd/Parser.hs \
618         src/Ganeti/Storage/Drbd/Types.hs \
619         src/Ganeti/Storage/Lvm/LVParser.hs \
620         src/Ganeti/Storage/Lvm/Types.hs \
621         src/Ganeti/Storage/Utils.hs \
622         src/Ganeti/THH.hs \
623         src/Ganeti/Types.hs \
624         src/Ganeti/Utils.hs
625
626 HS_TEST_SRCS = \
627         test/hs/Test/Ganeti/Attoparsec.hs \
628         test/hs/Test/Ganeti/BasicTypes.hs \
629         test/hs/Test/Ganeti/Common.hs \
630         test/hs/Test/Ganeti/Confd/Types.hs \
631         test/hs/Test/Ganeti/Confd/Utils.hs \
632         test/hs/Test/Ganeti/Daemon.hs \
633         test/hs/Test/Ganeti/Errors.hs \
634         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
635         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
636         test/hs/Test/Ganeti/HTools/CLI.hs \
637         test/hs/Test/Ganeti/HTools/Cluster.hs \
638         test/hs/Test/Ganeti/HTools/Container.hs \
639         test/hs/Test/Ganeti/HTools/Graph.hs \
640         test/hs/Test/Ganeti/HTools/Instance.hs \
641         test/hs/Test/Ganeti/HTools/Loader.hs \
642         test/hs/Test/Ganeti/HTools/Node.hs \
643         test/hs/Test/Ganeti/HTools/PeerMap.hs \
644         test/hs/Test/Ganeti/HTools/Types.hs \
645         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
646         test/hs/Test/Ganeti/JSON.hs \
647         test/hs/Test/Ganeti/Jobs.hs \
648         test/hs/Test/Ganeti/JQueue.hs \
649         test/hs/Test/Ganeti/Luxi.hs \
650         test/hs/Test/Ganeti/Network.hs \
651         test/hs/Test/Ganeti/Objects.hs \
652         test/hs/Test/Ganeti/OpCodes.hs \
653         test/hs/Test/Ganeti/Query/Filter.hs \
654         test/hs/Test/Ganeti/Query/Language.hs \
655         test/hs/Test/Ganeti/Query/Network.hs \
656         test/hs/Test/Ganeti/Query/Query.hs \
657         test/hs/Test/Ganeti/Rpc.hs \
658         test/hs/Test/Ganeti/Runtime.hs \
659         test/hs/Test/Ganeti/Ssconf.hs \
660         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
661         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
662         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
663         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
664         test/hs/Test/Ganeti/THH.hs \
665         test/hs/Test/Ganeti/TestCommon.hs \
666         test/hs/Test/Ganeti/TestHTools.hs \
667         test/hs/Test/Ganeti/TestHelper.hs \
668         test/hs/Test/Ganeti/Types.hs \
669         test/hs/Test/Ganeti/Utils.hs
670
671 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
672
673 HS_BUILT_SRCS = \
674         test/hs/Test/Ganeti/TestImports.hs \
675         src/Ganeti/Constants.hs \
676         src/Ganeti/Curl/Internal.hs \
677         src/Ganeti/Version.hs
678 HS_BUILT_SRCS_IN = \
679         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
680         src/Ganeti/Curl/Internal.hsc
681
682 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
683
684 $(RUN_IN_TEMPDIR): | stamp-directories
685
686 doc/html/index.html: ENABLE_MANPAGES =
687 doc/man-html/index.html: ENABLE_MANPAGES = 1
688 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
689
690 # Note: we use here an order-only prerequisite, as the contents of
691 # _autoconf.py are not actually influencing the html build output: it
692 # has to exist in order for the sphinx module to be loaded
693 # successfully, but we certainly don't want the docs to be rebuilt if
694 # it changes
695 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
696         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
697         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
698         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
699         | $(BUILT_PYTHON_SOURCES)
700         @test -n "$(SPHINX)" || \
701             { echo 'sphinx-build' not found during configure; exit 1; }
702 if !MANPAGES_IN_DOC
703         if test -n '$(ENABLE_MANPAGES)'; then \
704           echo 'Man pages in documentation were disabled at configure time' >&2; \
705           exit 1; \
706         fi
707 endif
708 ## Sphinx provides little control over what content should be included. Some
709 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
710 ## build two different versions of the documentation--once without man pages and
711 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
712 ## us with this, but requires running in a temporary directory. It moves the
713 ## correct files into place depending on environment variables.
714         dir=$(dir $@) && \
715         @mkdir_p@ $$dir && \
716         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
717         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
718             -d . \
719             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
720             -D release="$(PACKAGE_VERSION)" \
721             -D graphviz_dot="$(DOT)" \
722             -D enable_manpages="$(ENABLE_MANPAGES)" \
723             doc $(CURDIR)/$$dir && \
724         rm -f $$dir/.buildinfo $$dir/objects.inv
725         touch $@
726
727 doc/html: doc/html/index.html
728
729 doc/man-html: doc/man-html/index.html
730
731 doc/install-quick.rst: INSTALL
732 doc/news.rst: NEWS
733 doc/upgrade.rst: UPGRADE
734
735 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
736         set -e; \
737         { echo '.. This file is automatically updated at build time from $<.'; \
738           echo '.. Do not edit.'; \
739           echo; \
740           cat $<; \
741         } > $@
742
743 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
744         { echo '.. This file is automatically generated, do not edit!'; \
745           echo ''; \
746           echo 'Man pages'; \
747           echo '========='; \
748           echo; \
749           echo '.. toctree::'; \
750           echo '   :maxdepth: 1'; \
751           echo; \
752           for i in $(notdir $(mandocrst)); do \
753             echo "   $$i"; \
754           done | LC_ALL=C sort; \
755         } > $@
756
757 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
758 if MANPAGES_IN_DOC
759         { echo '.. This file is automatically updated at build time from $<.'; \
760           echo '.. Do not edit.'; \
761           echo; \
762           echo "$*"; \
763           echo '=========================================='; \
764           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
765         } > $@
766 else
767         echo 'Man pages in documentation were disabled at configure time' >&2; \
768         exit 1;
769 endif
770
771 # Things to build but not to install (add it to EXTRA_DIST if it should be
772 # distributed)
773 noinst_DATA = \
774         doc/html \
775         $(BUILT_EXAMPLES) \
776         doc/examples/bash_completion \
777         doc/examples/bash_completion-debug \
778         $(manhtml)
779
780 if MANPAGES_IN_DOC
781 noinst_DATA += doc/man-html
782 endif
783
784 gnt_scripts = \
785         scripts/gnt-backup \
786         scripts/gnt-cluster \
787         scripts/gnt-debug \
788         scripts/gnt-group \
789         scripts/gnt-instance \
790         scripts/gnt-job \
791         scripts/gnt-network \
792         scripts/gnt-node \
793         scripts/gnt-os \
794         scripts/gnt-storage
795
796 PYTHON_BOOTSTRAP_SBIN = \
797         daemons/ganeti-masterd \
798         daemons/ganeti-noded \
799         daemons/ganeti-rapi \
800         daemons/ganeti-watcher \
801         $(gnt_scripts)
802
803 PYTHON_BOOTSTRAP = \
804         $(PYTHON_BOOTSTRAP_SBIN) \
805         tools/burnin \
806         tools/ensure-dirs \
807         tools/node-cleanup \
808         tools/node-daemon-setup \
809         tools/prepare-node-join
810
811 qa_scripts = \
812         qa/__init__.py \
813         qa/ganeti-qa.py \
814         qa/qa_cluster.py \
815         qa/qa_config.py \
816         qa/qa_daemon.py \
817         qa/qa_env.py \
818         qa/qa_error.py \
819         qa/qa_group.py \
820         qa/qa_instance.py \
821         qa/qa_instance_utils.py \
822         qa/qa_job.py \
823         qa/qa_monitoring.py \
824         qa/qa_node.py \
825         qa/qa_os.py \
826         qa/qa_rapi.py \
827         qa/qa_tags.py \
828         qa/qa_utils.py
829
830 bin_SCRIPTS =
831 if WANT_HTOOLS
832 bin_SCRIPTS += $(HS_BIN_PROGS)
833 install-exec-hook:
834         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
835 # FIXME: this is a hardcoded logic, instead of auto-resolving
836         $(LN_S) -f ../../../bin/htools \
837           $(DESTDIR)$(iallocatorsdir)/hail
838         for role in $(HS_BIN_ROLES); do \
839           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
840         done
841 endif
842
843 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
844         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
845           echo "Error: cannot run unittests without the development" \
846                " libraries (see devnotes.rst)" 1>&2; \
847           exit 1; \
848         fi
849         @rm -f $(notdir $@).tix
850         $(GHC) --make \
851           $(HFLAGS) \
852           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
853           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
854           $(HEXTRA) $(HEXTRA_INT) $@
855         @touch "$@"
856
857 # for the test/hs/htest binary, we need to enable profiling/coverage
858 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
859
860 # we compile the hpc-htools binary with the program coverage
861 test/hs/hpc-htools: HEXTRA_INT=-fhpc
862
863 # we compile the hpc-mon-collector binary with the program coverage
864 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
865
866 # test dependency
867 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
868
869 # rules for building profiling-enabled versions of the haskell
870 # programs: hs-prof does the full two-step build, whereas
871 # hs-prof-quick does only the final rebuild (hs-prof must have been
872 # run before)
873 .PHONY: hs-prof hs-prof-quick
874 hs-prof:
875         @if [ -z "$(TARGET)" ]; then \
876           echo "You need to define TARGET when running this rule" 1>&2; \
877           exit 1; \
878         fi
879         $(MAKE) $(AM_MAKEFLAGS) clean
880         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
881         rm -f $(HS_ALL_PROGS)
882         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
883
884 hs-prof-quick:
885         @if [ -z "$(TARGET)" ]; then \
886           echo "You need to define TARGET when running this rule" 1>&2; \
887           exit 1; \
888         fi
889         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
890
891 dist_sbin_SCRIPTS = \
892         tools/ganeti-listrunner
893
894 nodist_sbin_SCRIPTS = \
895         $(PYTHON_BOOTSTRAP_SBIN) \
896         daemons/ganeti-cleaner
897
898 if ENABLE_CONFD
899 src/ganeti-confd: src/hconfd
900         cp -f $< $@
901
902 nodist_sbin_SCRIPTS += src/ganeti-confd
903 endif
904
905 if ENABLE_MOND
906 nodist_sbin_SCRIPTS += src/ganeti-mond
907 endif
908
909 python_scripts = \
910         tools/cfgshell \
911         tools/cfgupgrade \
912         tools/cfgupgrade12 \
913         tools/cluster-merge \
914         tools/confd-client \
915         tools/fmtjson \
916         tools/lvmstrap \
917         tools/move-instance \
918         tools/ovfconverter \
919         tools/sanitize-config
920
921 dist_tools_SCRIPTS = \
922         $(python_scripts) \
923         tools/burnin \
924         tools/kvm-console-wrapper \
925         tools/master-ip-setup \
926         tools/xen-console-wrapper
927
928 nodist_tools_python_scripts = \
929         tools/node-cleanup
930
931 nodist_tools_SCRIPTS = \
932         $(nodist_tools_python_scripts) \
933         tools/users-setup \
934         tools/vcluster-setup
935
936 pkglib_python_scripts = \
937         daemons/import-export \
938         tools/check-cert-expired
939
940 nodist_pkglib_python_scripts = \
941         tools/ensure-dirs \
942         tools/node-daemon-setup \
943         tools/prepare-node-join
944
945 myexeclib_SCRIPTS = \
946         daemons/daemon-util \
947         tools/kvm-ifup \
948         tools/vif-ganeti \
949         tools/net-common \
950         $(pkglib_python_scripts) \
951         $(HS_MYEXECLIB_PROGS)
952
953 nodist_myexeclib_SCRIPTS = \
954         $(nodist_pkglib_python_scripts)
955
956 EXTRA_DIST = \
957         NEWS \
958         UPGRADE \
959         epydoc.conf.in \
960         pylintrc \
961         autotools/build-bash-completion \
962         autotools/build-rpc \
963         autotools/check-header \
964         autotools/check-imports \
965         autotools/check-man-dashes \
966         autotools/check-man-references \
967         autotools/check-man-warnings \
968         autotools/check-news \
969         autotools/check-python-code \
970         autotools/check-tar \
971         autotools/check-version \
972         autotools/convert-constants \
973         autotools/docpp \
974         autotools/gen-py-coverage \
975         autotools/sphinx-wrapper \
976         autotools/testrunner \
977         autotools/wrong-hardcoded-paths \
978         $(RUN_IN_TEMPDIR) \
979         daemons/daemon-util.in \
980         daemons/ganeti-cleaner.in \
981         $(pkglib_python_scripts) \
982         devel/upload \
983         devel/webserver \
984         tools/kvm-ifup.in \
985         tools/vif-ganeti.in \
986         tools/net-common.in \
987         tools/users-setup.in \
988         tools/vcluster-setup.in \
989         $(docinput) \
990         doc/html \
991         $(BUILT_EXAMPLES:%=%.in) \
992         doc/examples/ganeti.default \
993         doc/examples/ganeti.default-debug \
994         doc/examples/hooks/ethers \
995         doc/examples/gnt-debug/README \
996         doc/examples/gnt-debug/delay0.json \
997         doc/examples/gnt-debug/delay50.json \
998         test/py/lockperf.py \
999         test/py/testutils.py \
1000         test/py/mocks.py \
1001         $(dist_TESTS) \
1002         $(TEST_FILES) \
1003         man/footer.rst \
1004         $(manrst) \
1005         $(maninput) \
1006         qa/qa-sample.json \
1007         $(qa_scripts) \
1008         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1009         $(HS_PROG_SRCS) \
1010         src/lint-hints.hs \
1011         test/hs/cli-tests-defs.sh \
1012         test/hs/offline-test.sh \
1013         .ghci
1014
1015 man_MANS = \
1016         man/ganeti-cleaner.8 \
1017         man/ganeti-confd.8 \
1018         man/ganeti-listrunner.8 \
1019         man/ganeti-masterd.8 \
1020         man/ganeti-mond.8 \
1021         man/ganeti-noded.8 \
1022         man/ganeti-os-interface.7 \
1023         man/ganeti-extstorage-interface.7 \
1024         man/ganeti-rapi.8 \
1025         man/ganeti-watcher.8 \
1026         man/ganeti.7 \
1027         man/gnt-backup.8 \
1028         man/gnt-cluster.8 \
1029         man/gnt-debug.8 \
1030         man/gnt-group.8 \
1031         man/gnt-network.8 \
1032         man/gnt-instance.8 \
1033         man/gnt-job.8 \
1034         man/gnt-node.8 \
1035         man/gnt-os.8 \
1036         man/gnt-storage.8 \
1037         man/hail.1 \
1038         man/harep.1 \
1039         man/hbal.1 \
1040         man/hcheck.1 \
1041         man/hinfo.1 \
1042         man/hscan.1 \
1043         man/hspace.1 \
1044         man/hroller.1 \
1045         man/htools.1 \
1046         man/mon-collector.7
1047
1048 # Remove extensions from all filenames in man_MANS
1049 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1050
1051 manrst = $(patsubst %,%.rst,$(mannoext))
1052 manhtml = $(patsubst %.rst,%.html,$(manrst))
1053 mangen = $(patsubst %.rst,%.gen,$(manrst))
1054 maninput = \
1055         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1056         $(patsubst %.html,%.html.in,$(manhtml)) \
1057         $(mangen)
1058
1059 TEST_FILES = \
1060         test/autotools/autotools-check-news.test \
1061         test/data/htools/clean-nonzero-score.data \
1062         test/data/htools/common-suffix.data \
1063         test/data/htools/empty-cluster.data \
1064         test/data/htools/hail-alloc-drbd.json \
1065         test/data/htools/hail-alloc-invalid-network.json \
1066         test/data/htools/hail-alloc-invalid-twodisks.json \
1067         test/data/htools/hail-alloc-restricted-network.json \
1068         test/data/htools/hail-alloc-spindles.json \
1069         test/data/htools/hail-alloc-twodisks.json \
1070         test/data/htools/hail-change-group.json \
1071         test/data/htools/hail-invalid-reloc.json \
1072         test/data/htools/hail-node-evac.json \
1073         test/data/htools/hail-reloc-drbd.json \
1074         test/data/htools/hbal-excl-tags.data \
1075         test/data/htools/hbal-split-insts.data \
1076         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1077         test/data/htools/hspace-tiered-dualspec.data \
1078         test/data/htools/hspace-tiered-exclusive.data \
1079         test/data/htools/hspace-tiered-ipolicy.data \
1080         test/data/htools/hspace-tiered-mixed.data \
1081         test/data/htools/hspace-tiered-resourcetypes.data \
1082         test/data/htools/hspace-tiered.data \
1083         test/data/htools/invalid-node.data \
1084         test/data/htools/missing-resources.data \
1085         test/data/htools/multiple-master.data \
1086         test/data/htools/multiple-tags.data \
1087         test/data/htools/n1-failure.data \
1088         test/data/htools/rapi/groups.json \
1089         test/data/htools/rapi/info.json \
1090         test/data/htools/rapi/instances.json \
1091         test/data/htools/rapi/nodes.json \
1092         test/data/htools/hroller-full.data \
1093         test/data/htools/hroller-nodegroups.data \
1094         test/data/htools/hroller-nonredundant.data \
1095         test/data/htools/hroller-online.data \
1096         test/data/htools/unique-reboot-order.data \
1097         test/hs/shelltests/htools-balancing.test \
1098         test/hs/shelltests/htools-basic.test \
1099         test/hs/shelltests/htools-dynutil.test \
1100         test/hs/shelltests/htools-excl.test \
1101         test/hs/shelltests/htools-hail.test \
1102         test/hs/shelltests/htools-hroller.test \
1103         test/hs/shelltests/htools-hspace.test \
1104         test/hs/shelltests/htools-invalid.test \
1105         test/hs/shelltests/htools-multi-group.test \
1106         test/hs/shelltests/htools-no-backend.test \
1107         test/hs/shelltests/htools-rapi.test \
1108         test/hs/shelltests/htools-single-group.test \
1109         test/hs/shelltests/htools-text-backend.test \
1110         test/hs/shelltests/htools-mon-collector.test \
1111         test/data/bdev-drbd-8.0.txt \
1112         test/data/bdev-drbd-8.3.txt \
1113         test/data/bdev-drbd-8.4.txt \
1114         test/data/bdev-drbd-disk.txt \
1115         test/data/bdev-drbd-net-ip4.txt \
1116         test/data/bdev-drbd-net-ip6.txt \
1117         test/data/bdev-rbd/json_output_empty.txt \
1118         test/data/bdev-rbd/json_output_extra_matches.txt \
1119         test/data/bdev-rbd/json_output_no_matches.txt \
1120         test/data/bdev-rbd/json_output_ok.txt \
1121         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1122         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1123         test/data/bdev-rbd/plain_output_new_ok.txt \
1124         test/data/bdev-rbd/plain_output_old_empty.txt \
1125         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1126         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1127         test/data/bdev-rbd/plain_output_old_ok.txt \
1128         test/data/bdev-rbd/output_invalid.txt \
1129         test/data/cert1.pem \
1130         test/data/cert2.pem \
1131         test/data/cluster_config_2.7.json \
1132         test/data/cluster_config_2.8.json \
1133         test/data/instance-minor-pairing.txt \
1134         test/data/ip-addr-show-dummy0.txt \
1135         test/data/ip-addr-show-lo-ipv4.txt \
1136         test/data/ip-addr-show-lo-ipv6.txt \
1137         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1138         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1139         test/data/ip-addr-show-lo-oneline.txt \
1140         test/data/ip-addr-show-lo.txt \
1141         test/data/kvm_0.12.5_help.txt \
1142         test/data/kvm_0.15.90_help.txt \
1143         test/data/kvm_0.9.1_help.txt \
1144         test/data/kvm_0.9.1_help_boot_test.txt \
1145         test/data/kvm_1.0_help.txt \
1146         test/data/kvm_1.1.2_help.txt \
1147         test/data/lvs_lv.txt \
1148         test/data/NEWS_OK.txt \
1149         test/data/NEWS_previous_unreleased.txt \
1150         test/data/ovfdata/compr_disk.vmdk.gz \
1151         test/data/ovfdata/config.ini \
1152         test/data/ovfdata/corrupted_resources.ovf \
1153         test/data/ovfdata/empty.ini \
1154         test/data/ovfdata/empty.ovf \
1155         test/data/ovfdata/ganeti.mf \
1156         test/data/ovfdata/ganeti.ovf \
1157         test/data/ovfdata/gzip_disk.ovf \
1158         test/data/ovfdata/new_disk.vmdk \
1159         test/data/ovfdata/no_disk.ini \
1160         test/data/ovfdata/no_disk_in_ref.ovf \
1161         test/data/ovfdata/no_os.ini \
1162         test/data/ovfdata/no_ovf.ova \
1163         test/data/ovfdata/other/rawdisk.raw \
1164         test/data/ovfdata/ova.ova \
1165         test/data/ovfdata/rawdisk.raw \
1166         test/data/ovfdata/second_disk.vmdk \
1167         test/data/ovfdata/unsafe_path.ini \
1168         test/data/ovfdata/virtualbox.ovf \
1169         test/data/ovfdata/wrong_config.ini \
1170         test/data/ovfdata/wrong_extension.ovd \
1171         test/data/ovfdata/wrong_manifest.mf \
1172         test/data/ovfdata/wrong_manifest.ovf \
1173         test/data/ovfdata/wrong_ova.ova \
1174         test/data/ovfdata/wrong_xml.ovf \
1175         test/data/proc_diskstats.txt \
1176         test/data/proc_drbd8.txt \
1177         test/data/proc_drbd80-emptyline.txt \
1178         test/data/proc_drbd80-emptyversion.txt \
1179         test/data/proc_drbd83.txt \
1180         test/data/proc_drbd83_sync.txt \
1181         test/data/proc_drbd83_sync_want.txt \
1182         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1183         test/data/proc_drbd84.txt \
1184         test/data/proc_drbd84_sync.txt \
1185         test/data/qa-minimal-nodes-instances-only.json \
1186         test/data/sys_drbd_usermode_helper.txt \
1187         test/data/vgreduce-removemissing-2.02.02.txt \
1188         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1189         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1190         test/data/vgs-missing-pvs-2.02.02.txt \
1191         test/data/vgs-missing-pvs-2.02.66.txt \
1192         test/data/xen-xm-info-4.0.1.txt \
1193         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1194         test/data/xen-xm-list-4.0.1-four-instances.txt \
1195         test/data/xen-xm-list-long-4.0.1.txt \
1196         test/data/xen-xm-uptime-4.0.1.txt \
1197         test/py/ganeti-cli.test \
1198         test/py/gnt-cli.test \
1199         test/py/import-export_unittest-helper
1200
1201
1202 python_tests = \
1203         doc/examples/rapi_testutils.py \
1204         test/py/cfgupgrade_unittest.py \
1205         test/py/docs_unittest.py \
1206         test/py/ganeti.asyncnotifier_unittest.py \
1207         test/py/ganeti.backend_unittest-runasroot.py \
1208         test/py/ganeti.backend_unittest.py \
1209         test/py/ganeti.cli_unittest.py \
1210         test/py/ganeti.client.gnt_cluster_unittest.py \
1211         test/py/ganeti.client.gnt_instance_unittest.py \
1212         test/py/ganeti.client.gnt_job_unittest.py \
1213         test/py/ganeti.cmdlib_unittest.py \
1214         test/py/ganeti.compat_unittest.py \
1215         test/py/ganeti.confd.client_unittest.py \
1216         test/py/ganeti.config_unittest.py \
1217         test/py/ganeti.constants_unittest.py \
1218         test/py/ganeti.daemon_unittest.py \
1219         test/py/ganeti.errors_unittest.py \
1220         test/py/ganeti.hooks_unittest.py \
1221         test/py/ganeti.ht_unittest.py \
1222         test/py/ganeti.http_unittest.py \
1223         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1224         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1225         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1226         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1227         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1228         test/py/ganeti.hypervisor_unittest.py \
1229         test/py/ganeti.impexpd_unittest.py \
1230         test/py/ganeti.jqueue_unittest.py \
1231         test/py/ganeti.jstore_unittest.py \
1232         test/py/ganeti.locking_unittest.py \
1233         test/py/ganeti.luxi_unittest.py \
1234         test/py/ganeti.masterd.iallocator_unittest.py \
1235         test/py/ganeti.masterd.instance_unittest.py \
1236         test/py/ganeti.mcpu_unittest.py \
1237         test/py/ganeti.netutils_unittest.py \
1238         test/py/ganeti.objects_unittest.py \
1239         test/py/ganeti.opcodes_unittest.py \
1240         test/py/ganeti.outils_unittest.py \
1241         test/py/ganeti.ovf_unittest.py \
1242         test/py/ganeti.qlang_unittest.py \
1243         test/py/ganeti.query_unittest.py \
1244         test/py/ganeti.rapi.baserlib_unittest.py \
1245         test/py/ganeti.rapi.client_unittest.py \
1246         test/py/ganeti.rapi.resources_unittest.py \
1247         test/py/ganeti.rapi.rlib2_unittest.py \
1248         test/py/ganeti.rapi.testutils_unittest.py \
1249         test/py/ganeti.rpc_unittest.py \
1250         test/py/ganeti.runtime_unittest.py \
1251         test/py/ganeti.serializer_unittest.py \
1252         test/py/ganeti.server.rapi_unittest.py \
1253         test/py/ganeti.ssconf_unittest.py \
1254         test/py/ganeti.ssh_unittest.py \
1255         test/py/ganeti.storage.bdev_unittest.py \
1256         test/py/ganeti.storage.container_unittest.py \
1257         test/py/ganeti.storage.drbd_unittest.py \
1258         test/py/ganeti.storage.filestorage_unittest.py \
1259         test/py/ganeti.tools.burnin_unittest.py \
1260         test/py/ganeti.tools.ensure_dirs_unittest.py \
1261         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1262         test/py/ganeti.tools.prepare_node_join_unittest.py \
1263         test/py/ganeti.uidpool_unittest.py \
1264         test/py/ganeti.utils.algo_unittest.py \
1265         test/py/ganeti.utils.filelock_unittest.py \
1266         test/py/ganeti.utils.hash_unittest.py \
1267         test/py/ganeti.utils.io_unittest-runasroot.py \
1268         test/py/ganeti.utils.io_unittest.py \
1269         test/py/ganeti.utils.log_unittest.py \
1270         test/py/ganeti.utils.lvm_unittest.py \
1271         test/py/ganeti.utils.mlock_unittest.py \
1272         test/py/ganeti.utils.nodesetup_unittest.py \
1273         test/py/ganeti.utils.process_unittest.py \
1274         test/py/ganeti.utils.retry_unittest.py \
1275         test/py/ganeti.utils.storage_unittest.py \
1276         test/py/ganeti.utils.text_unittest.py \
1277         test/py/ganeti.utils.wrapper_unittest.py \
1278         test/py/ganeti.utils.x509_unittest.py \
1279         test/py/ganeti.utils_unittest.py \
1280         test/py/ganeti.vcluster_unittest.py \
1281         test/py/ganeti.workerpool_unittest.py \
1282         test/py/pycurl_reset_unittest.py \
1283         test/py/qa.qa_config_unittest.py \
1284         test/py/tempfile_fork_unittest.py
1285
1286 haskell_tests = test/hs/htest
1287
1288 dist_TESTS = \
1289         test/py/check-cert-expired_unittest.bash \
1290         test/py/daemon-util_unittest.bash \
1291         test/py/ganeti-cleaner_unittest.bash \
1292         test/py/import-export_unittest.bash \
1293         test/py/cli-test.bash \
1294         test/py/bash_completion.bash
1295
1296 if !PY_NODEV
1297         dist_TESTS += $(python_tests)
1298 endif
1299
1300 nodist_TESTS =
1301 check_SCRIPTS =
1302
1303 if WANT_HSTESTS
1304 nodist_TESTS += $(haskell_tests)
1305 dist_TESTS += test/hs/offline-test.sh
1306 check_SCRIPTS += \
1307         test/hs/hpc-htools \
1308         test/hs/hpc-mon-collector \
1309         $(HS_BUILT_TEST_HELPERS)
1310 endif
1311
1312 TESTS = $(dist_TESTS) $(nodist_TESTS)
1313
1314 # Environment for all tests
1315 PLAIN_TESTS_ENVIRONMENT = \
1316         PYTHONPATH=. \
1317         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1318         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1319         $(RUN_IN_TEMPDIR)
1320
1321 # Environment for tests run by automake
1322 TESTS_ENVIRONMENT = \
1323         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1324
1325 all_python_code = \
1326         $(dist_sbin_SCRIPTS) \
1327         $(python_scripts) \
1328         $(pkglib_python_scripts) \
1329         $(nodist_pkglib_python_scripts) \
1330         $(nodist_tools_python_scripts) \
1331         $(pkgpython_PYTHON) \
1332         $(client_PYTHON) \
1333         $(cmdlib_PYTHON) \
1334         $(hypervisor_PYTHON) \
1335         $(storage_PYTHON) \
1336         $(rapi_PYTHON) \
1337         $(server_PYTHON) \
1338         $(pytools_PYTHON) \
1339         $(http_PYTHON) \
1340         $(confd_PYTHON) \
1341         $(masterd_PYTHON) \
1342         $(impexpd_PYTHON) \
1343         $(utils_PYTHON) \
1344         $(watcher_PYTHON) \
1345         $(noinst_PYTHON) \
1346         $(qa_scripts)
1347
1348 if !PY_NODEV
1349         all_python_code += $(python_tests)
1350 endif
1351
1352 srclink_files = \
1353         man/footer.rst \
1354         test/py/check-cert-expired_unittest.bash \
1355         test/py/daemon-util_unittest.bash \
1356         test/py/ganeti-cleaner_unittest.bash \
1357         test/py/import-export_unittest.bash \
1358         test/py/cli-test.bash \
1359         test/py/bash_completion.bash \
1360         test/hs/offline-test.sh \
1361         test/hs/cli-tests-defs.sh \
1362         $(all_python_code) \
1363         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1364         $(docinput)
1365
1366 check_python_code = \
1367         $(BUILD_BASH_COMPLETION) \
1368         $(CHECK_IMPORTS) \
1369         $(CHECK_HEADER) \
1370         $(DOCPP) \
1371         $(all_python_code)
1372
1373 lint_python_code = \
1374         ganeti \
1375         ganeti/http/server.py \
1376         $(dist_sbin_SCRIPTS) \
1377         $(python_scripts) \
1378         $(pkglib_python_scripts) \
1379         $(BUILD_BASH_COMPLETION) \
1380         $(CHECK_IMPORTS) \
1381         $(CHECK_HEADER) \
1382         $(DOCPP) \
1383         $(PYTHON_BOOTSTRAP)
1384
1385 standalone_python_modules = \
1386         lib/rapi/client.py \
1387         tools/ganeti-listrunner
1388
1389 pep8_python_code = \
1390         ganeti \
1391         ganeti/http/server.py \
1392         $(dist_sbin_SCRIPTS) \
1393         $(python_scripts) \
1394         $(pkglib_python_scripts) \
1395         $(BUILD_BASH_COMPLETION) \
1396         $(CHECK_HEADER) \
1397         $(DOCPP) \
1398         $(PYTHON_BOOTSTRAP) \
1399         qa
1400
1401 test/py/daemon-util_unittest.bash: daemons/daemon-util
1402
1403 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1404
1405 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1406
1407 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1408         sed -f $(REPLACE_VARS_SED) < $< > $@
1409         chmod +x $@
1410
1411 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1412         sed -f $(REPLACE_VARS_SED) < $< > $@
1413         chmod +x $@
1414
1415 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1416         sed -f $(REPLACE_VARS_SED) < $< > $@
1417         chmod +x $@
1418
1419 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1420         sed -f $(REPLACE_VARS_SED) < $< > $@
1421         chmod +x $@
1422
1423 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1424         sed -f $(REPLACE_VARS_SED) < $< > $@
1425         chmod +x $@
1426
1427 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1428         sed -f $(REPLACE_VARS_SED) < $< > $@
1429         chmod +x $@
1430
1431 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1432         sed -f $(REPLACE_VARS_SED) < $< > $@
1433
1434 doc/examples/bash_completion: BC_ARGS = --compact
1435 doc/examples/bash_completion-debug: BC_ARGS =
1436
1437 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1438         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1439         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1440         daemons/ganeti-cleaner \
1441         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1442         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1443           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1444
1445 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1446         lib/build/shell_example_lexer.py \
1447         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1448         @echo "Checking $< for hardcoded paths..."
1449         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1450           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1451           exit 1; \
1452         fi
1453         set -e ; \
1454         trap 'echo auto-removing $@; rm $@' EXIT; \
1455         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1456         $(CHECK_MAN_REFERENCES) $@; \
1457         trap - EXIT
1458
1459 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1460         @test -n "$(PANDOC)" || \
1461           { echo 'pandoc' not found during configure; exit 1; }
1462         set -o pipefail -e; \
1463         trap 'echo auto-removing $@; rm $@' EXIT; \
1464         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1465           sed -e 's/\\@/@/g' > $@; \
1466         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1467         $(CHECK_MAN_DASHES) $@; \
1468         trap - EXIT
1469
1470 man/%.html.in: man/%.gen man/footer.rst
1471         @test -n "$(PANDOC)" || \
1472           { echo 'pandoc' not found during configure; exit 1; }
1473         set -o pipefail ; \
1474         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1475           sed -e 's/\\@/@/g' > $@
1476
1477 man/%: man/%.in  $(REPLACE_VARS_SED)
1478         sed -f $(REPLACE_VARS_SED) < $< > $@
1479
1480 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1481         sed -f $(REPLACE_VARS_SED) < $< > $@
1482
1483 vcs-version:
1484         if test -d .git; then \
1485           git describe > $@; \
1486         elif test ! -f $@ ; then \
1487           echo "Cannot auto-generate $@ file"; exit 1; \
1488         fi
1489
1490 .PHONY: clean-vcs-version
1491 clean-vcs-version:
1492         rm -f vcs-version
1493
1494 .PHONY: regen-vcs-version
1495 regen-vcs-version:
1496         @set -e; \
1497         cd $(srcdir); \
1498         if test -d .git; then \
1499           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1500           git describe > $$T; \
1501           if ! cmp --quiet $$T vcs-version; then \
1502             mv $$T vcs-version; \
1503           fi; \
1504         fi
1505
1506 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1507         vcs-version $(built_base_sources)
1508         set -e; \
1509         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1510         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1511
1512 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1513         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1514         lib/jstore.py $(RUN_IN_TEMPDIR) \
1515         $(CONVERT_CONSTANTS) $(built_base_sources) \
1516         | lib/_vcsversion.py
1517         set -e; \
1518         { cat $< ; \
1519           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1520         } > $@
1521
1522 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1523         hsc2hs -o $@ $<
1524
1525 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1526         $(built_base_sources)
1527         set -e; \
1528         { cat $< ; \
1529           echo ; \
1530           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1531             echo "import $$name ()" ; \
1532           done ; \
1533         } > $@
1534
1535 lib/_autoconf.py: Makefile | stamp-directories
1536         set -e; \
1537         { echo '# This file is automatically generated, do not edit!'; \
1538           echo '#'; \
1539           echo ''; \
1540           echo '"""Build-time configuration for Ganeti.'; \
1541           echo '';\
1542           echo 'This file is autogenerated by the build process.'; \
1543           echo 'For any changes you need to re-run ./configure (and'; \
1544           echo 'not edit by hand).'; \
1545           echo ''; \
1546           echo '"""'; \
1547           echo ''; \
1548           echo '# pylint: disable=C0301,C0324'; \
1549           echo '# because this is autogenerated, we do not want'; \
1550           echo '# style warnings' ; \
1551           echo ''; \
1552           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1553           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1554           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1555           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1556           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1557           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1558           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1559           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1560           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1561           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1562           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1563           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1564           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1565           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1566           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1567           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1568           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1569           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1570           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1571           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1572           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1573           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1574           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1575           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1576           echo "KVM_PATH = '$(KVM_PATH)'"; \
1577           echo "IP_PATH = '$(IP_PATH)'"; \
1578           echo "SOCAT_PATH = '$(SOCAT)'"; \
1579           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1580           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1581           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1582           echo "TOOLSDIR = '$(toolsdir)'"; \
1583           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1584           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1585           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1586           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1587           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1588           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1589           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1590           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1591           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1592           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1593           echo "RAPI_USER = '$(RAPI_USER)'"; \
1594           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1595           echo "CONFD_USER = '$(CONFD_USER)'"; \
1596           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1597           echo "NODED_USER = '$(NODED_USER)'"; \
1598           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1599           echo "MOND_USER = '$(MOND_USER)'"; \
1600           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1601           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1602           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1603           echo "HTOOLS = True"; \
1604           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1605           echo "XEN_CMD = '$(XEN_CMD)'"; \
1606           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1607           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1608           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1609 ## Write dictionary with man page name as the key and the section number as the
1610 ## value
1611           echo "MAN_PAGES = {"; \
1612           for i in $(notdir $(man_MANS)); do \
1613             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1614           done; \
1615           echo "}"; \
1616         } > $@
1617
1618 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1619         set -e; \
1620         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1621         { echo '# This file is automatically generated, do not edit!'; \
1622           echo '#'; \
1623           echo ''; \
1624           echo '"""Build-time VCS version number for Ganeti.'; \
1625           echo '';\
1626           echo 'This file is autogenerated by the build process.'; \
1627           echo 'For any changes you need to re-run ./configure (and'; \
1628           echo 'not edit by hand).'; \
1629           echo ''; \
1630           echo '"""'; \
1631           echo ''; \
1632           echo '# pylint: disable=C0301,C0324'; \
1633           echo '# because this is autogenerated, we do not want'; \
1634           echo '# style warnings' ; \
1635           echo ''; \
1636           echo "VCS_VERSION = '$$VCSVER'"; \
1637         } > $@
1638
1639 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1640         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1641
1642 $(SHELL_ENV_INIT): Makefile stamp-directories
1643         set -e; \
1644         { echo '# Allow overriding for tests'; \
1645           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1646           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1647           echo; \
1648           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1649           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1650           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1651           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1652           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1653         } > $@
1654
1655 ## Writes sed script to replace placeholders with build-time values. The
1656 ## additional quotes after the first @ sign are necessary to stop configure
1657 ## from replacing those values as well.
1658 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1659         set -e; \
1660         { echo 's#@''PREFIX@#$(prefix)#g'; \
1661           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1662           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1663           echo 's#@''BINDIR@#$(bindir)#g'; \
1664           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1665           echo 's#@''LIBDIR@#$(libdir)#g'; \
1666           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1667           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1668           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1669           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1670           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1671           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1672           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1673           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1674           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1675           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1676           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1677           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1678           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1679           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1680           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1681           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1682           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1683           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1684           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1685           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1686           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1687           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1688           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1689           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1690           echo; \
1691           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1692           echo '  r $(SHELL_ENV_INIT)'; \
1693           echo '  d'; \
1694           echo '}'; \
1695         } > $@
1696
1697 # Using deferred evaluation
1698 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1699 daemons/ganeti-watcher: MODULE = ganeti.watcher
1700 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1701 tools/burnin: MODULE = ganeti.tools.burnin
1702 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1703 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1704 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1705 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1706 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1707
1708 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1709         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1710         set -e; \
1711         { echo '#!/usr/bin/python'; \
1712           echo '# This file is automatically generated, do not edit!'; \
1713           echo "# Edit $(MODULE) instead."; \
1714           echo; \
1715           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1716           echo; \
1717           echo '# pylint: disable=C0103'; \
1718           echo '# C0103: Invalid name'; \
1719           echo; \
1720           echo 'import sys'; \
1721           echo 'import $(MODULE) as main'; \
1722           echo; \
1723           echo '# Temporarily alias commands until bash completion'; \
1724           echo '# generator is changed'; \
1725           echo 'if hasattr(main, "commands"):'; \
1726           echo '  commands = main.commands # pylint: disable=E1101'; \
1727           echo 'if hasattr(main, "aliases"):'; \
1728           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1729           echo; \
1730           echo 'if __name__ == "__main__":'; \
1731           echo '  sys.exit(main.Main())'; \
1732         } > $@
1733         chmod u+x $@
1734
1735 $(HS_BUILT_TEST_HELPERS): Makefile
1736         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1737         set -e; \
1738         { echo '#!/bin/sh'; \
1739           echo '# This file is automatically generated, do not edit!'; \
1740           echo "# Edit Makefile.am instead."; \
1741           echo; \
1742           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1743         } > $@
1744         chmod u+x $@
1745
1746 stamp-directories: Makefile
1747         $(MAKE) $(AM_MAKEFLAGS) ganeti
1748         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1749         touch $@
1750
1751 # We need to create symlinks because "make distcheck" will not install Python
1752 # files when building.
1753 stamp-srclinks: Makefile | stamp-directories
1754         set -e; \
1755         for i in $(srclink_files); do \
1756           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1757             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1758           fi; \
1759         done
1760         touch $@
1761
1762 .PHONY: ganeti
1763 ganeti:
1764         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1765
1766 .PHONY: check-dirs
1767 check-dirs: $(GENERATED_FILES)
1768         @set -e; \
1769         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1770           error=; \
1771           while read dir; do \
1772             case "$$dir" in \
1773               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1774               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1775             esac; \
1776           done; \
1777           for dir in $(DIRS); do \
1778             if ! test -d "$$dir"; then \
1779               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1780               error=1; \
1781             fi \
1782           done; \
1783           test -z "$$error"; \
1784         }
1785
1786 .PHONY: check-local
1787 check-local: check-dirs $(GENERATED_FILES)
1788         $(CHECK_PYTHON_CODE) $(check_python_code)
1789         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1790         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1791         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1792         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1793         error= ; \
1794         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1795           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1796           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1797             echo "Incorrect version in README, expected $$expver" >&2; \
1798             error=1; \
1799           fi; \
1800           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1801               doc/security.rst; do \
1802             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1803               "Documents Ganeti version $$expver"; then \
1804               echo "Incorrect version in $$file, expected $$expver" >&2; \
1805               error=1; \
1806             fi; \
1807           done; \
1808           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1809             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1810             error=1; \
1811           fi; \
1812           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1813             ".. Last updated for Ganeti $$expver"; then \
1814             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1815             error=1; \
1816           fi; \
1817         fi; \
1818         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1819           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1820             echo "Longest line in $$file is longer than 80 characters" >&2; \
1821             error=1; \
1822           fi; \
1823         done; \
1824         test -z "$$error"
1825
1826 .PHONY: hs-tests
1827 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1828         @rm -f htest.tix
1829         ./test/hs/htest
1830
1831 .PHONY: hs-shell
1832 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1833         @rm -f hpc-htools.tix hpc-mon-collector.tix
1834         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1835
1836 .PHONY: hs-check
1837 hs-check: hs-tests hs-shell
1838
1839 # E111: indentation is not a multiple of four
1840 # E121: continuation line indentation is not a multiple of four
1841 #       (since our indent level is not 4)
1842 # E125: continuation line does not distinguish itself from next logical line
1843 #       (since our indent level is not 4)
1844 # E127: continuation line over-indented for visual indent
1845 #       (since our indent level is not 4)
1846 # note: do NOT add E128 here; it's a valid style error in most cases!
1847 # I've seen real errors, but also some cases were we indent wrongly
1848 # due to line length; try to rework the cases where it is triggered,
1849 # instead of silencing it
1850 # E261: at least two spaces before inline comment
1851 # E501: line too long (80 characters)
1852 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1853
1854 # For excluding pep8 expects filenames only, not whole paths
1855 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1856
1857 LINT_TARGETS = pylint pylint-qa
1858 if HAS_PEP8
1859 LINT_TARGETS += pep8
1860 endif
1861 if HAS_HLINT
1862 LINT_TARGETS += hlint
1863 endif
1864
1865 .PHONY: lint
1866 lint: $(LINT_TARGETS)
1867
1868 .PHONY: pylint
1869 pylint: $(GENERATED_FILES)
1870         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1871         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1872
1873 .PHONY: pylint-qa
1874 pylint-qa: $(GENERATED_FILES)
1875         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1876         cd $(top_srcdir)/qa && \
1877           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1878           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1879
1880 .PHONY: pep8
1881 pep8: $(GENERATED_FILES)
1882         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1883         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1884           --repeat $(pep8_python_code)
1885
1886 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1887 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1888 .PHONY: hlint
1889 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1890         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1891         @rm -f doc/hs-lint.html
1892         if tty -s; then C="-c"; else C=""; fi; \
1893         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1894           --ignore "Use first" \
1895           --ignore "Use &&&" \
1896           --ignore "Use void" \
1897           --ignore "Reduce duplication" \
1898           --hint src/lint-hints \
1899           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1900         @if [ ! -f doc/hs-lint.html ]; then \
1901           echo "All good" > doc/hs-lint.html; \
1902         fi
1903
1904 # a dist hook rule for updating the vcs-version file; this is
1905 # hardcoded due to where it needs to build the file...
1906 dist-hook:
1907         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1908         rm -f $(top_distdir)/vcs-version
1909         cp -p $(srcdir)/vcs-version $(top_distdir)
1910
1911 # a distcheck hook rule for catching revision control directories
1912 distcheck-hook:
1913         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1914           echo "Found revision control files in final archive." 1>&2; \
1915           exit 1; \
1916         fi
1917         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1918           echo "Found Python byte code in final archive." 1>&2; \
1919           exit 1; \
1920         fi
1921         if find $(top_distdir) -name '*~' | grep .; then \
1922           echo "Found backup files in final archive." 1>&2; \
1923           exit 1; \
1924         fi
1925 # Empty files or directories should not be distributed. They can cause
1926 # unnecessary warnings for packagers. Directories used by automake during
1927 # distcheck must be excluded.
1928         if find $(top_distdir) -empty -and -not \( \
1929             -path $(top_distdir)/_build -or \
1930             -path $(top_distdir)/_inst \) | grep .; then \
1931           echo "Found empty files or directories in final archive." 1>&2; \
1932           exit 1; \
1933         fi
1934         if test -e $(top_distdir)/doc/man-html; then \
1935           echo "Found documentation including man pages in final archive" >&2; \
1936           exit 1; \
1937         fi
1938
1939 # Backwards compatible distcheck-release target
1940 distcheck-release: distcheck
1941
1942 distrebuildcheck: dist
1943         set -e; \
1944         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1945         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1946         cd $$builddir; \
1947         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1948         cd $(distdir); \
1949         ./configure; \
1950         $(MAKE) maintainer-clean; \
1951         cp $(abs_srcdir)/vcs-version .; \
1952         ./configure; \
1953         $(MAKE) $(AM_MAKEFLAGS)
1954
1955 dist-release: dist
1956         set -e; \
1957         for i in $(DIST_ARCHIVES); do \
1958           echo -n "Checking $$i ... "; \
1959           autotools/check-tar < $$i; \
1960           echo OK; \
1961         done
1962
1963 install-exec-local:
1964         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1965           "$(DESTDIR)${localstatedir}/log/ganeti" \
1966           "$(DESTDIR)${localstatedir}/run/ganeti"
1967
1968 .PHONY: apidoc
1969 if WANT_HSAPIDOC
1970 apidoc: py-apidoc hs-apidoc
1971 else
1972 apidoc: py-apidoc
1973 endif
1974
1975 .PHONY: py-apidoc
1976 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1977         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1978         $(RUN_IN_TEMPDIR) epydoc -v \
1979           --conf $(CURDIR)/epydoc.conf \
1980           --output $(CURDIR)/$(APIDOC_PY_DIR)
1981
1982 .PHONY: hs-apidoc
1983 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1984
1985 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1986         @test -n "$(HSCOLOUR)" || \
1987             { echo 'HsColour' not found during configure; exit 1; }
1988         @test -n "$(HADDOCK)" || \
1989             { echo 'haddock' not found during configure; exit 1; }
1990         rm -rf $(APIDOC_HS_DIR)/*
1991         for i in $(ALL_APIDOC_HS_DIRS); do \
1992           @mkdir_p@ $$i; \
1993           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1994         done
1995         set -e ; \
1996         export LC_ALL=en_US.UTF-8; \
1997         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1998         if [ "$(HS_PARALLEL3)" ]; \
1999         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2000         fi; \
2001         if [ "$(HS_REGEX_PCRE)" ]; \
2002         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2003         fi; \
2004         for file in $(HS_LIBTESTBUILT_SRCS); do \
2005           f_nosrc=$${file##src/}; \
2006           f_notst=$${f_nosrc##test/hs/}; \
2007           f_html=$${f_notst%%.hs}.html; \
2008           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2009         done ; \
2010         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2011           -t ganeti -p src/haddock-prologue \
2012           --source-module="%{MODULE/.//}.html" \
2013           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2014           $$OPTGHC \
2015           $(HS_LIBTESTBUILT_SRCS)
2016
2017 .PHONY: TAGS
2018 TAGS: $(GENERATED_FILES)
2019         rm -f TAGS
2020         $(GHC) -e ":etags" -v0 \
2021           $(filter-out -O -Werror,$(HFLAGS)) \
2022           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2023           $(HS_LIBTEST_SRCS)
2024         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2025           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2026           -path './qa/*.py' | \
2027           etags -l python -a -
2028
2029 .PHONY: coverage
2030
2031 COVERAGE_TESTS=
2032 if WANT_HTOOLS
2033 COVERAGE_TESTS += hs-coverage
2034 endif
2035 if !PY_NODEV
2036 COVERAGE_TESTS += py-coverage
2037 endif
2038
2039 coverage: $(COVERAGE_TESTS)
2040
2041 .PHONY: py-coverage
2042 py-coverage: $(GENERATED_FILES) $(python_tests)
2043         @test -n "$(PYCOVERAGE)" || \
2044             { echo 'python-coverage' not found during configure; exit 1; }
2045         set -e; \
2046         COVERAGE=$(PYCOVERAGE) \
2047         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2048         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2049         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2050         $(PLAIN_TESTS_ENVIRONMENT) \
2051         $(abs_top_srcdir)/autotools/gen-py-coverage \
2052         $(python_tests)
2053
2054 .PHONY: hs-coverage
2055 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2056         rm -f *.tix
2057         $(MAKE) $(AM_MAKEFLAGS) hs-check
2058         @mkdir_p@ $(COVERAGE_HS_DIR)
2059         hpc sum --union $(HPCEXCL) \
2060           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2061         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2062         hpc report coverage-hs.tix
2063         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2064
2065 # Special "kind-of-QA" target for htools, needs special setup (all
2066 # tools compiled with -fhpc)
2067 .PHONY: live-test
2068 live-test: all
2069         set -e ; \
2070         cd src; \
2071         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2072         rm -f *.tix *.mix; \
2073         ./live-test.sh; \
2074         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2075           --output=live-test.tix ; \
2076         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2077         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2078           --srcdir=.. $(HPCEXCL) ; \
2079         hpc report --srcdir=.. live-test $(HPCEXCL)
2080
2081 commit-check: autotools-check distcheck lint apidoc
2082
2083 autotools-check:
2084         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2085   $(abs_top_srcdir)/test/autotools/*-*.test \
2086   -- --hide-successes
2087
2088 .PHONY: gitignore-check
2089 gitignore-check:
2090         @if [ -n "`git status --short`" ]; then \
2091           echo "Git status is not clean!" 1>&2 ; \
2092           git status --short; \
2093           exit 1; \
2094         fi
2095
2096 # target to rebuild all man pages (both groff and html output)
2097 .PHONY: man
2098 man: $(man_MANS) $(manhtml)
2099
2100 # Target that builds all binaries (including those that are not
2101 # rebuilt except when running the tests)
2102 .PHONY: really-all
2103 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2104
2105 # we don't need the ancient implicit rules:
2106 %: %,v
2107 %: RCS/%,v
2108 %: RCS/%
2109 %: s.%
2110 %: SCCS/s.%
2111
2112 -include ./Makefile.local
2113
2114 # vim: set noet :